Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/HeuristicLab.Algorithms.ScatterSearch-3.3.csproj
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/HeuristicLab.Algorithms.ScatterSearch-3.3.csproj	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/HeuristicLab.Algorithms.ScatterSearch-3.3.csproj	(revision 7786)
@@ -87,23 +87,14 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="IImprovementOperator.cs" />
+    <Compile Include="IPathRelinker.cs" />
     <Compile Include="SolutionPool2TierUpdateMethod.cs" />
-    <Compile Include="DiversityCalculator.cs" />
-    <Compile Include="IPathRelinker.cs" />
-    <Compile Include="Knapsack\BinaryVectorDiversityCalculator.cs" />
+    <Compile Include="SimilarityCalculator.cs" />
+    <Compile Include="Knapsack\KnapsackSimilarityCalculator.cs" />
     <Compile Include="Knapsack\KnapsackMultipleGuidesPathRelinker.cs" />
     <Compile Include="Knapsack\KnapsackSimultaneousPathRelinker.cs" />
     <Compile Include="Knapsack\KnapsackPathRelinker.cs" />
-    <Compile Include="TestFunctions\TestFunctionsZakharovImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsSumSquaresImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsSchwefelImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsRosenbrockImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsMatyasImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsLevyImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsGriewankImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsBoothImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsBealeImprovementOperator.cs" />
-    <Compile Include="TestFunctions\TestFunctionsAckleyImprovementOperator.cs" />
     <Compile Include="TestFunctions\TestFunctionsPathRelinker.cs" />
-    <Compile Include="TestFunctions\RealVectorDiversityCalculator.cs" />
+    <Compile Include="TestFunctions\TestFunctionsSimilarityCalculator.cs" />
     <Compile Include="TestFunctions\TestFunctionsImprovementOperator.cs" />
     <Compile Include="TravelingSalesman\TravelingSalesmanMultipleGuidesPathRelinker.cs" />
@@ -111,10 +102,6 @@
     <Compile Include="TravelingSalesman\TravelingSalesmanPathRelinker.cs" />
     <Compile Include="PathRelinker.cs" />
-    <Compile Include="Knapsack\INBinaryVectorCrossover.cs" />
-    <Compile Include="IScatterSearchTargetProcessor.cs" />
-    <Compile Include="Knapsack\NBinaryVectorCrossover.cs" />
-    <Compile Include="Knapsack\NChildCrossover.cs" />
     <Compile Include="OffspringProcessor.cs" />
-    <Compile Include="TravelingSalesman\PermutationDiversityCalculator.cs" />
+    <Compile Include="TravelingSalesman\TravelingSalesmanSimilarityCalculator.cs" />
     <Compile Include="TravelingSalesman\TravelingSalesmanImprovementOperator.cs" />
     <None Include="HeuristicLab.snk" />
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IImprovementOperator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IImprovementOperator.cs	(revision 7786)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IImprovementOperator.cs	(revision 7786)
@@ -0,0 +1,32 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Algorithms.ScatterSearch {
+  /// <summary>
+  /// An interface which represents an operator for improvement.
+  /// </summary>
+  public interface IImprovementOperator : IOperator, IParameterizedNamedItem, IDeepCloneable, ICloneable {
+  }
+}
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/IPathRelinker.cs	(revision 7786)
@@ -20,6 +20,7 @@
 #endregion
 
+using System;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
 
 namespace HeuristicLab.Algorithms.ScatterSearch {
@@ -27,6 +28,5 @@
   /// An interface which represents an operator for path relinking.
   /// </summary>
-  public interface IPathRelinker : ICrossover {
-    ILookupParameter<ItemArray<IItem>> ParentsParameter { get; }
+  public interface IPathRelinker : IOperator, IParameterizedNamedItem, IDeepCloneable, ICloneable {
   }
 }
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackImprovementOperator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackImprovementOperator.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackImprovementOperator.cs	(revision 7786)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Linq;
 using HeuristicLab.Common;
@@ -27,5 +26,4 @@
 using HeuristicLab.Encodings.BinaryVectorEncoding;
 using HeuristicLab.Operators;
-using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -38,47 +36,24 @@
   [Item("KnapsackImprovementOperator", "An operator that improves knapsack solutions.")]
   [StorableClass]
-  public sealed class KnapsackImprovementOperator : SingleSuccessorOperator, ILocalImprovementOperator, IScatterSearchTargetProcessor {
-    #region Problem properties
-    public Type ProblemType {
-      get { return typeof(KnapsackProblem); }
-    }
-    [Storable]
-    private KnapsackProblem problem;
-    public IProblem Problem {
-      get { return problem; }
-      set { problem = (KnapsackProblem)value; }
-    }
-    #endregion
-
+  public sealed class KnapsackImprovementOperator : SingleSuccessorOperator, IImprovementOperator {
     #region Parameter properties
     public ScopeParameter CurrentScopeParameter {
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
     }
-    public IValueLookupParameter<IntArray> ValuesParameter {
-      get { return (IValueLookupParameter<IntArray>)Parameters["Values"]; }
+    public ILookupParameter<IntValue> KnapsackCapacityParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["KnapsackCapacity"]; }
     }
-    public IValueLookupParameter<IntArray> WeightsParameter {
-      get { return (IValueLookupParameter<IntArray>)Parameters["Weights"]; }
-    }
-    public IValueLookupParameter<IntValue> KnapsackCapacityParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["KnapsackCapacity"]; }
+    public ILookupParameter<DoubleValue> PenaltyParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Penalty"]; }
     }
     public IValueLookupParameter<IItem> TargetParameter {
       get { return (IValueLookupParameter<IItem>)Parameters["Target"]; }
     }
-    public IValueLookupParameter<DoubleValue> PenaltyParameter {
-      get { return (IValueLookupParameter<DoubleValue>)Parameters["Penalty"]; }
+    public ILookupParameter<IntArray> ValuesParameter {
+      get { return (ILookupParameter<IntArray>)Parameters["Values"]; }
     }
-    #region ILocalImprovementOperator Parameters
-    public IValueLookupParameter<IntValue> MaximumIterationsParameter {
-      get { return (IValueLookupParameter<IntValue>)Parameters["MaximumIterations"]; }
+    public ILookupParameter<IntArray> WeightsParameter {
+      get { return (ILookupParameter<IntArray>)Parameters["Weights"]; }
     }
-    public ILookupParameter<IntValue> EvaluatedSolutionsParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["EvaluatedSolutions"]; }
-    }
-    public ILookupParameter<ResultCollection> ResultsParameter {
-      get { return (ILookupParameter<ResultCollection>)Parameters["Results"]; }
-    }
-    #endregion
     #endregion
 
@@ -86,4 +61,15 @@
     private IScope CurrentScope {
       get { return CurrentScopeParameter.ActualValue; }
+    }
+    private IntValue KnapsackCapacity {
+      get { return KnapsackCapacityParameter.ActualValue; }
+      set { KnapsackCapacityParameter.ActualValue = value; }
+    }
+    private DoubleValue Penalty {
+      get { return PenaltyParameter.ActualValue; }
+      set { PenaltyParameter.ActualValue = value; }
+    }
+    private IItem Target {
+      get { return TargetParameter.ActualValue; }
     }
     private IntArray Values {
@@ -95,32 +81,18 @@
       set { WeightsParameter.ActualValue = value; }
     }
-    private IntValue KnapsackCapacity {
-      get { return KnapsackCapacityParameter.ActualValue; }
-      set { KnapsackCapacityParameter.ActualValue = value; }
-    }
-    private IItem Target {
-      get { return TargetParameter.ActualValue; }
-    }
-    private DoubleValue Penalty {
-      get { return PenaltyParameter.ActualValue; }
-      set { PenaltyParameter.ActualValue = value; }
-    }
     #endregion
 
     [StorableConstructor]
     private KnapsackImprovementOperator(bool deserializing) : base(deserializing) { }
-    private KnapsackImprovementOperator(KnapsackImprovementOperator original, Cloner cloner)
-      : base(original, cloner) {
-      this.problem = cloner.Clone(original.problem);
-    }
+    private KnapsackImprovementOperator(KnapsackImprovementOperator original, Cloner cloner) : base(original, cloner) { }
     public KnapsackImprovementOperator()
       : base() {
       #region Create parameters
       Parameters.Add(new ScopeParameter("CurrentScope"));
-      Parameters.Add(new ValueLookupParameter<IntArray>("Values"));
-      Parameters.Add(new ValueLookupParameter<IntArray>("Weights"));
-      Parameters.Add(new ValueLookupParameter<IntValue>("KnapsackCapacity"));
+      Parameters.Add(new LookupParameter<IntValue>("KnapsackCapacity"));
+      Parameters.Add(new LookupParameter<DoubleValue>("Penalty"));
       Parameters.Add(new ValueLookupParameter<IItem>("Target"));
-      Parameters.Add(new ValueLookupParameter<DoubleValue>("Penalty"));
+      Parameters.Add(new LookupParameter<IntArray>("Values"));
+      Parameters.Add(new LookupParameter<IntArray>("Weights"));
       #endregion
       TargetParameter.ActualName = "KnapsackSolution"; // temporary solution for the knapsack problem
@@ -132,5 +104,5 @@
 
     public override IOperation Apply() {
-      var sol = CurrentScope.Variables[TargetParameter.ActualName].Value as BinaryVector;
+      BinaryVector sol = CurrentScope.Variables[TargetParameter.ActualName].Value as BinaryVector;
 
       // calculate value-to-weight ratio
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackMultipleGuidesPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackMultipleGuidesPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackMultipleGuidesPathRelinker.cs	(revision 7786)
@@ -54,6 +54,6 @@
         throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
 
-      var v1 = initiator.Clone() as BinaryVector;
-      var targets = new BinaryVector[guides.Length];
+      BinaryVector v1 = initiator.Clone() as BinaryVector;
+      BinaryVector[] targets = new BinaryVector[guides.Length];
       Array.Copy(guides, targets, guides.Length);
 
@@ -61,16 +61,16 @@
         throw new ArgumentException("At least one solution is of different length.");
 
-      var solutions = new List<BinaryVector>();
+      IList<BinaryVector> solutions = new List<BinaryVector>();
       for (int i = 0; i < v1.Length; i++) {
         // TODO: path relinking
       }
 
-      var selection = new List<IItem>();
+      IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
-        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        int noSol = (int)(solutions.Count * n.Value);
         if (noSol <= 0) noSol++;
-        var stepSize = (double)solutions.Count / (double)noSol;
+        double stepSize = (double)solutions.Count / (double)noSol;
         for (int i = 0; i < noSol; i++)
-          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+          selection.Add(solutions.ElementAt((int)((i + 1) * stepSize - stepSize * 0.5)));
       }
 
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackPathRelinker.cs	(revision 7786)
@@ -54,11 +54,11 @@
         throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
 
-      var v1 = initiator.Clone() as BinaryVector;
-      var v2 = guide as BinaryVector;
+      BinaryVector v1 = initiator.Clone() as BinaryVector;
+      BinaryVector v2 = guide as BinaryVector;
 
       if (v1.Length != v2.Length)
         throw new ArgumentException("The solutions are of different length.");
 
-      var solutions = new List<BinaryVector>();
+      IList<BinaryVector> solutions = new List<BinaryVector>();
       for (int i = 0; i < v1.Length; i++)
         if (v1[i] != v2[i]) {
@@ -67,11 +67,11 @@
         }
 
-      var selection = new List<IItem>();
+      IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
-        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        int noSol = (int)(solutions.Count * n.Value);
         if (noSol <= 0) noSol++;
-        var stepSize = (double)solutions.Count / (double)noSol;
+        double stepSize = (double)solutions.Count / (double)noSol;
         for (int i = 0; i < noSol; i++)
-          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+          selection.Add(solutions.ElementAt((int)((i + 1) * stepSize - stepSize * 0.5)));
       }
 
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimilarityCalculator.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimilarityCalculator.cs	(revision 7786)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimilarityCalculator.cs	(revision 7786)
@@ -0,0 +1,53 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Algorithms.ScatterSearch.Knapsack {
+  /// <summary>
+  /// An operator that performs similarity calculation between two knapsack solutions.
+  /// </summary>
+  [Item("KnapsackSimilarityCalculator", "An operator that performs similarity calculation between two knapsack solutions.")]
+  [StorableClass]
+  public sealed class KnapsackSimilarityCalculator : SimilarityCalculator {
+    [StorableConstructor]
+    private KnapsackSimilarityCalculator(bool deserializing) : base(deserializing) { }
+    private KnapsackSimilarityCalculator(KnapsackSimilarityCalculator original, Cloner cloner) : base(original, cloner) { }
+    public KnapsackSimilarityCalculator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new KnapsackSimilarityCalculator(this, cloner);
+    }
+
+    protected override double CalculateDiversity(IScope left, IScope right) {
+      BinaryVector sol1 = left.Variables["KnapsackSolution"].Value as BinaryVector;
+      BinaryVector sol2 = right.Variables["KnapsackSolution"].Value as BinaryVector;
+
+      double similarity = 0.0;
+      for (int i = 0; i < sol1.Length; i++)
+        if (sol1[i] == sol2[i]) similarity++;
+      return similarity / sol1.Length;
+    }
+  }
+}
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimultaneousPathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimultaneousPathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/Knapsack/KnapsackSimultaneousPathRelinker.cs	(revision 7786)
@@ -54,13 +54,13 @@
         throw new ArgumentException("RelinkingAccuracy must be greater than 0.");
 
-      var firstInitiator = initiator.Clone() as BinaryVector;
-      var firstGuide = guide.Clone() as BinaryVector;
-      var secondInitiator = firstGuide.Clone() as BinaryVector;
-      var secondGuide = firstInitiator.Clone() as BinaryVector;
+      BinaryVector firstInitiator = initiator.Clone() as BinaryVector;
+      BinaryVector firstGuide = guide.Clone() as BinaryVector;
+      BinaryVector secondInitiator = firstGuide.Clone() as BinaryVector;
+      BinaryVector secondGuide = firstInitiator.Clone() as BinaryVector;
 
       if (firstInitiator.Length != firstGuide.Length)
         throw new ArgumentException("The solutions are of different length.");
 
-      var solutions = new List<BinaryVector>();
+      IList<BinaryVector> solutions = new List<BinaryVector>();
       for (int i = 0; i < firstInitiator.Length / 2; i++) {
         if (firstInitiator[i] != firstGuide[i]) {
@@ -68,5 +68,5 @@
           solutions.Add(firstInitiator.Clone() as BinaryVector);
         }
-        var j = secondInitiator.Length - 1 - i;
+        int j = secondInitiator.Length - 1 - i;
         if (secondInitiator[j] != secondGuide[j]) {
           secondInitiator[j] = secondGuide[j];
@@ -75,11 +75,11 @@
       }
 
-      var selection = new List<IItem>();
+      IList<IItem> selection = new List<IItem>();
       if (solutions.Count > 0) {
-        var noSol = (int)Math.Round(solutions.Count * n.Value);
+        int noSol = (int)(solutions.Count * n.Value);
         if (noSol <= 0) noSol++;
-        var stepSize = (double)solutions.Count / (double)noSol;
+        double stepSize = (double)solutions.Count / (double)noSol;
         for (int i = 0; i < noSol; i++)
-          selection.Add(solutions.ElementAt((int)Math.Round((i + 1) * stepSize - stepSize * 0.5)));
+          selection.Add(solutions.ElementAt((int)((i + 1) * stepSize - stepSize * 0.5)));
       }
 
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/OffspringProcessor.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/OffspringProcessor.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/OffspringProcessor.cs	(revision 7786)
@@ -32,5 +32,5 @@
   [Item("OffspringProcessor", "An operator that creates a subscope with subscopes for every variable in the current scope.")]
   [StorableClass]
-  public sealed class OffspringProcessor : SingleSuccessorOperator, IScatterSearchTargetProcessor {
+  public sealed class OffspringProcessor : SingleSuccessorOperator {
     #region Parameter properties
     public ScopeParameter CurrentScopeParameter {
@@ -54,5 +54,11 @@
     private OffspringProcessor(bool deserializing) : base(deserializing) { }
     private OffspringProcessor(OffspringProcessor original, Cloner cloner) : base(original, cloner) { }
-    public OffspringProcessor() : base() { Initialize(); }
+    public OffspringProcessor()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new ScopeParameter("CurrentScope"));
+      Parameters.Add(new ValueLookupParameter<IItem>("Target"));
+      #endregion
+    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -60,17 +66,9 @@
     }
 
-    private void Initialize() {
-      #region Create parameters
-      Parameters.Add(new ScopeParameter("CurrentScope"));
-      Parameters.Add(new ValueLookupParameter<IItem>("Target"));
-      #endregion
-      TargetParameter.ActualName = "KnapsackSolution"; // temporary solution for the knapsack problem
-    }
-
     public override IOperation Apply() {
-      var offspringSolutions = CurrentScope.Variables;
-      var offspringScope = new Scope("Offspring");
+      VariableCollection offspringSolutions = CurrentScope.Variables;
+      IScope offspringScope = new Scope("Offspring");
       foreach (var solution in offspringSolutions) {
-        var scope = new Scope();
+        IScope scope = new Scope();
         scope.Variables.Add(new Variable(TargetParameter.ActualName, solution.Value));
         offspringScope.SubScopes.Add(scope);
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PathRelinker.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PathRelinker.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PathRelinker.cs	(revision 7786)
@@ -38,9 +38,9 @@
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
     }
+    public ILookupParameter<ItemArray<IItem>> ParentsParameter {
+      get { return (IScopeTreeLookupParameter<IItem>)Parameters["Parents"]; }
+    }
     public IValueParameter<PercentValue> RelinkingAccuracyParameter {
       get { return (IValueParameter<PercentValue>)Parameters["RelinkingAccuracy"]; }
-    }
-    public ILookupParameter<ItemArray<IItem>> ParentsParameter {
-      get { return (IScopeTreeLookupParameter<IItem>)Parameters["Parents"]; }
     }
     #endregion
@@ -50,9 +50,9 @@
       get { return CurrentScopeParameter.ActualValue; }
     }
+    private ItemArray<IItem> Parents {
+      get { return ParentsParameter.ActualValue; }
+    }
     private PercentValue RelinkingAccuracy {
       get { return RelinkingAccuracyParameter.Value; }
-    }
-    private ItemArray<IItem> Parents {
-      get { return ParentsParameter.ActualValue; }
     }
     #endregion
@@ -65,11 +65,11 @@
       #region Create parameters
       Parameters.Add(new ScopeParameter("CurrentScope"));
+      Parameters.Add(new ScopeTreeLookupParameter<IItem>("Parents"));
       Parameters.Add(new ValueParameter<PercentValue>("RelinkingAccuracy", new PercentValue(0.25)));
-      Parameters.Add(new ScopeTreeLookupParameter<IItem>("Parents"));
       #endregion
     }
 
     public sealed override IOperation Apply() {
-      var relinkedSolutions = Relink(Parents, RelinkingAccuracy);
+      ItemArray<IItem> relinkedSolutions = Relink(Parents, RelinkingAccuracy);
       for (int i = 0; i < relinkedSolutions.Length; i++)
         CurrentScope.Variables.Add(new Variable(string.Format("Child {0}", i), relinkedSolutions[i]));
Index: /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PopulationRebuildMethod.cs
===================================================================
--- /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PopulationRebuildMethod.cs	(revision 7785)
+++ /branches/ScatterSearch/HeuristicLab.Algorithms.ScatterSearch/3.3/PopulationRebuildMethod.cs	(revision 7786)
@@ -45,9 +45,9 @@
       get { return (IValueLookupParameter<IntValue>)Parameters["NumberOfHighQualitySolutions"]; }
     }
+    public IValueLookupParameter<IItem> QualityParameter {
+      get { return (IValueLookupParameter<IItem>)Parameters["Quality"]; }
+    }
     public IValueLookupParameter<IntValue> ReferenceSetSizeParameter {
       get { return (IValueLookupParameter<IntValue>)Parameters["ReferenceSetSize"]; }
-    }
-    public IValueLookupParameter<IItem> QualityParameter {
-      get { return (IValueLookupParameter<IItem>)Parameters["Quality"]; }
     }
     #endregion
@@ -65,10 +65,10 @@
       set { NumberOfHighQualitySolutionsParameter.ActualValue = value; }
     }
+    private IItem Quality {
+      get { return QualityParameter.ActualValue; }
+    }
     private IntValue ReferenceSetSize {
       get { return ReferenceSetSizeParameter.ActualValue; }
       set { ReferenceSetSizeParameter.ActualValue = value; }
-    }
-    private IItem Quality {
-      get { return QualityParameter.ActualValue; }
     }
     #endregion
@@ -77,5 +77,14 @@
     private PopulationRebuildMethod(bool deserializing) : base(deserializing) { }
     private PopulationRebuildMethod(PopulationRebuildMethod original, Cloner cloner) : base(original, cloner) { }
-    public PopulationRebuildMethod() : base() { Initialize(); }
+    public PopulationRebuildMethod()
+      : base() {
+      #region Create parameters
+      Parameters.Add(new ScopeParameter("CurrentScope"));
+      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfHighQualitySolutions"));
+      Parameters.Add(new ValueLookupParameter<IItem>("Quality"));
+      Parameters.Add(new ValueLookupParameter<IntValue>("ReferenceSetSize"));
+      #endregion
+    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -83,17 +92,7 @@
     }
 
-    private void Initialize() {
-      #region Create parameters
-      Parameters.Add(new ScopeParameter("CurrentScope"));
-      Parameters.Add(new ValueLookupParameter<BoolValue>("Maximization"));
-      Parameters.Add(new ValueLookupParameter<IntValue>("NumberOfHighQualitySolutions"));
-      Parameters.Add(new ValueLookupParameter<IntValue>("ReferenceSetSize"));
-      Parameters.Add(new ValueLookupParameter<IItem>("Quality"));
-      #endregion
-    }
-
     public override IOperation Apply() {
-      var populationScope = CurrentScope.SubScopes[0];
-      var referenceSetScope = CurrentScope.SubScopes[1];
+      IScope populationScope = CurrentScope.SubScopes[0];
+      IScope referenceSetScope = CurrentScope.SubScopes[1];
       var orderedReferenceSet = Maximization.Value ? referenceSetScope.SubScopes.OrderByDescending(r => r.Variables[QualityParameter.ActualName].Value) :
                                                      referenceSetScope.SubScopes.OrderBy(r => r.Variables[QualityParameter.ActualName].Value);
